/*
 * Copyright 2009-2010 the original author or authors.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package com.aurorasoftworks.signal.examples.context.ui;


import javax.microedition.lcdui.Display;
import javax.microedition.lcdui.TextBox;

import com.aurorasoftworks.signal.examples.context.core.Greeter;
import com.aurorasoftworks.signal.runtime.ui.mvc.AbstractApplicationMIDlet;



/**
 * A sample MIDlet that loads a context generated from greeter.xml.
 * 
 * @author Marek
 */
public class ContextMIDlet extends AbstractApplicationMIDlet
{
	public ContextMIDlet() throws Exception
	{
		/* 
		 * The context could also be loaded by invoking
		 * ContextClassLoader.getInstance().loadContext(
		 * "com.aurorasoftworks.signal.examples.context.core.GreeterContext") directly.
		 */
		
		super("com.aurorasoftworks.signal.examples.context.core.GreeterContext");
		
		Greeter g = (Greeter) getContext().getBean("greeter");
		
		Display.getDisplay(this).setCurrent(new TextBox(
				"Title", g.getGreeting(), 10, 0));
	}
}
