/*
 * Copyright 2009-2010 the original author or authors.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package com.aurorasoftworks.signal.examples.context.core;


import static org.testng.AssertJUnit.assertNotNull;

import org.testng.annotations.Test;

import com.aurorasoftworks.signal.examples.context.core.Greeter;
import com.aurorasoftworks.signal.examples.context.core.MessageSource;
import com.aurorasoftworks.signal.runtime.core.context.ContextClassLoader;
import com.aurorasoftworks.signal.runtime.core.context.ContextException;
import com.aurorasoftworks.signal.runtime.core.context.IContext;


@Test
public class GreeterContextClassTest
{
	public void testLoadContext() throws ContextException
	{
		IContext ctx = ContextClassLoader.getInstance()
				.loadContext("com.aurorasoftworks.signal.examples.context.core.GreeterContext");
		assertNotNull((Greeter) ctx.getBean("greeter"));
		assertNotNull((MessageSource) ctx.getBean("msgSource"));
	}
}
