package com.aurorasoftworks.signal.examples.core;


public class Account implements IAccount
{
	private String firstName;

	private String lastName;
	
	private boolean canPlaceOrders;
	
	private boolean canViewOrders;
	
	private boolean canModifyOrders;
	
	public Account()
	{
		this("", "");
	}
	
	public Account(IAccount account)
	{
		restore(account);
	}
	
	public Account(String firstName, String lastName)
	{
		this.firstName = firstName;
		this.lastName = lastName;
	}

	public String getFirstName()
	{
		return firstName;
	}

	public void setFirstName(String firstName)
	{
		this.firstName = firstName;
	}

	public String getLastName()
	{
		return lastName;
	}

	public void setLastName(String lastName)
	{
		this.lastName = lastName;
	}
	
	public String toString()
	{
		return firstName + " " + lastName;
	}

	public boolean getCanPlaceOrders()
	{
		return canPlaceOrders;
	}

	public void setCanPlaceOrders(boolean canPlaceOrders)
	{
		this.canPlaceOrders = canPlaceOrders;
	}

	public boolean getCanViewOrders()
	{
		return canViewOrders;
	}

	public void setCanViewOrders(boolean canViewOrders)
	{
		this.canViewOrders = canViewOrders;
	}

	public boolean getCanModifyOrders()
	{
		return canModifyOrders;
	}

	public void setCanModifyOrders(boolean canModifyOrders)
	{
		this.canModifyOrders = canModifyOrders;
	}
	
	public void restore(IAccount account)
	{
		firstName = account.getFirstName();
		lastName = account.getLastName();
		canPlaceOrders = account.getCanPlaceOrders();
		canViewOrders = account.getCanViewOrders();
		canModifyOrders = account.getCanModifyOrders();
	}
}
