package com.aurorasoftworks.signal.examples.ui.mvc.lwuit;



import com.aurorasoftworks.signal.examples.core.IAccount;
import com.aurorasoftworks.signal.runtime.ui.mvc.lwuit.AbstractViewFlowController;
import com.aurorasoftworks.signal.runtime.ui.mvc.lwuit.ICommandHandler;
import com.sun.lwuit.Command;


public class AccountInfoViewController extends AbstractViewFlowController
		implements IAccountSelectedEvent
{
	public AccountInfoViewController(AccountInfoView view)
	{
		super(view);
		
		registerCommandHandler(AccountInfoView.NEXT_CMD,
				new ICommandHandler()
		{
			public void handleCommand(Command cmd)
			{
				if (getAccountInfoView().validate())
				{
					((IAccountCreationEvent) getCaller()).onAccountSubmitted(
							getAccountInfoView().getAccount());
				}
			}
		});
		
		registerCommandHandler(AccountInfoView.CANCEL_CMD,
				new ICommandHandler()
		{
			public void handleCommand(Command cmd)
			{
				((IAccountCreationEvent) getCaller()).onAccountCancelled(
						getAccountInfoView().getAccount());
			}
		});
	}
	
	protected AccountInfoView getAccountInfoView()
	{
		return (AccountInfoView) getView();
	}

	public void onAccountSelected(IAccount account)
	{
		getAccountInfoView().setAccount(account);		
	}
}
