/*
 * Copyright 2009-2010 the original author or authors.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package com.aurorasoftworks.signal.examples.ui.mvc.lwuit;


import com.aurorasoftworks.signal.runtime.core.context.ContextException;
import com.aurorasoftworks.signal.runtime.core.context.IContext;
import com.aurorasoftworks.signal.runtime.core.context.IContextLoader;
import com.aurorasoftworks.signal.runtime.ui.mvc.lwuit.AbstractApplicationMIDlet;



public class AccountMIDlet extends AbstractApplicationMIDlet
{
	public AccountMIDlet() throws Exception
	{
		/* 
		 * The context could also be loaded by invoking
		 * ContextClassLoader.getInstance().loadContext(
		 * "com.aurorasoftworks.signal.examples.mvc.lwuit.ui.ApplicationContext")
		 * directly.
		 */
		
		super("com.aurorasoftworks.signal.examples.ui.mvc.lwuit."
				+ "ApplicationContext");
		
		((IAccountListRequestedEvent) getContext().getBean(
				IAccountListRequestedEvent.class)).onAccountListRequested();
	}

	protected IContext loadContext(String contextName, IContextLoader loader)
			throws ContextException
	{
		return super.loadContext(contextName, loader);
	}
}
