package com.aurorasoftworks.signal.examples.ui.mvc.lwuit;



import com.aurorasoftworks.signal.examples.core.IAccount;
import com.sun.lwuit.CheckBox;
import com.sun.lwuit.Command;
import com.sun.lwuit.Form;
import com.sun.lwuit.Label;
import com.sun.lwuit.events.ActionEvent;
import com.sun.lwuit.events.ActionListener;
import com.sun.lwuit.layouts.BoxLayout;


public class AccountPermissionsView extends Form
{
	public static final Command SAVE_CMD = new Command("Save");
	
	public static final Command CANCEL_CMD = new Command("Cancel");
	
	private CheckBox canPlaceOrdersCheck = new CheckBox("Can place orders");
	
	private CheckBox canViewOrdersCheck = new CheckBox("Can view orders");
	
	private CheckBox canModifyOrdersCheck = new CheckBox("Can modify orders");
	
	private IAccount account;

	public AccountPermissionsView()
	{
		setLayout(new BoxLayout(BoxLayout.Y_AXIS));

		addComponent(new Label("Permissions"));
		addComponent(canPlaceOrdersCheck);
		addComponent(canViewOrdersCheck);
		addComponent(canModifyOrdersCheck);
		
		canPlaceOrdersCheck.addActionListener(new ActionListener()
		{
			public void actionPerformed(ActionEvent arg0)
			{
				account.setCanPlaceOrders(canPlaceOrdersCheck.isSelected());				
			}
		});
		canViewOrdersCheck.addActionListener(new ActionListener()
		{
			public void actionPerformed(ActionEvent arg0)
			{
				account.setCanViewOrders(canViewOrdersCheck.isSelected());				
			}
		});
		canModifyOrdersCheck.addActionListener(new ActionListener()
		{
			public void actionPerformed(ActionEvent arg0)
			{
				account.setCanModifyOrders(canModifyOrdersCheck.isSelected());				
			}
		});
		
		addCommand(CANCEL_CMD);
		addCommand(SAVE_CMD);
	}
	
	public IAccount getAccount()
	{
		return account;
	}

	public void setAccount(IAccount account)
	{
		this.account = account;
		
		canPlaceOrdersCheck.setSelected(account.getCanPlaceOrders());
		canViewOrdersCheck.setSelected(account.getCanViewOrders());
		canModifyOrdersCheck.setSelected(account.getCanModifyOrders());
	}	
}
