package com.aurorasoftworks.signal.examples.ui.mvc.lwuit;



import com.aurorasoftworks.signal.examples.core.IAccount;
import com.aurorasoftworks.signal.runtime.ui.mvc.lwuit.AbstractViewFlowController;
import com.aurorasoftworks.signal.runtime.ui.mvc.lwuit.ICommandHandler;
import com.sun.lwuit.Command;


public class AccountPermissionsViewController
		extends AbstractViewFlowController implements IAccountSelectedEvent
{
	public AccountPermissionsViewController(AccountPermissionsView view)
	{
		super(view);
		
		registerCommandHandler(AccountPermissionsView.SAVE_CMD,
				new ICommandHandler()
		{
			public void handleCommand(Command cmd)
			{
				((IAccountCreationEvent) getCaller()).onAccountSubmitted(
						getAccountPermissionView().getAccount());
			}
		});
		
		registerCommandHandler(AccountPermissionsView.CANCEL_CMD,
				new ICommandHandler()
		{
			public void handleCommand(Command cmd)
			{
				((IAccountCreationEvent) getCaller()).onAccountCancelled(
						getAccountPermissionView().getAccount());
			}
		});
	}
	
	protected AccountPermissionsView getAccountPermissionView()
	{
		return (AccountPermissionsView) getView();
	}

	public void onAccountSelected(IAccount account)
	{
		getAccountPermissionView().setAccount(account);
	}
}
