package com.aurorasoftworks.signal.examples.ui.mvc.midp;


import com.aurorasoftworks.signal.examples.core.IAccount;
import com.aurorasoftworks.signal.runtime.ui.mvc.AbstractFlowController;



public class AccountFlowController extends AbstractFlowController
		implements IEditAccountEvent, IAccountCreationEvent
{
	private IAccountSelectedEvent editAccountInfoEvent;
	
	private IAccountSelectedEvent editAccountPermissionsEvent;
	
	private IAccountSelectedEvent [] childControllers;
	
	private int childControllerIndex = 0;

	public IAccountSelectedEvent getEditAccountInfoEvent()
	{
		return editAccountInfoEvent;
	}

	public void setEditAccountInfoEvent(
			IAccountSelectedEvent editAccountInfoEvent)
	{
		this.editAccountInfoEvent = editAccountInfoEvent;
	}

	public IAccountSelectedEvent getEditAccountPermissionsEvent()
	{
		return editAccountPermissionsEvent;
	}

	public void setEditAccountPermissionsEvent(
			IAccountSelectedEvent editAccountPermissionsEvent)
	{
		this.editAccountPermissionsEvent = editAccountPermissionsEvent;
	}

	public void onEditAccount(IAccount account)
	{
		if (childControllers == null)
		{
			childControllers = new IAccountSelectedEvent[]
			{
				editAccountInfoEvent, editAccountPermissionsEvent,
			};
		}
		childControllerIndex = 0;
		
		editAccountInfoEvent.onAccountSelected(account);		
	}

	public void onAccountCancelled(IAccount account)
	{
		((IAccountCreationEvent) getCaller()).onAccountCancelled(
				account);
	}

	public void onAccountSubmitted(IAccount account)
	{
		childControllerIndex++;
		
		/* If this is not the last controller move to the next one */
		if (childControllerIndex < childControllers.length)
		{
			childControllers[childControllerIndex].onAccountSelected(account);
		}
		/* Otherwise end the flow by calling the parent controller */
		else
		{
			((IAccountCreationEvent) getCaller()).onAccountSubmitted(
					account);
		}
	}
}
