package com.aurorasoftworks.signal.examples.ui.mvc.midp;


import javax.microedition.lcdui.Alert;
import javax.microedition.lcdui.AlertType;
import javax.microedition.lcdui.Command;
import javax.microedition.lcdui.Display;
import javax.microedition.lcdui.Form;
import javax.microedition.lcdui.Item;
import javax.microedition.lcdui.ItemStateListener;
import javax.microedition.lcdui.TextField;

import com.aurorasoftworks.signal.examples.core.IAccount;
import com.aurorasoftworks.signal.runtime.ui.mvc.IDispatcher;



public class AccountInfoView extends Form
{
	public static final Command NEXT_CMD = new Command(
			"Next", Command.ITEM, 1);
	
	public static final Command CANCEL_CMD = new Command(
			"Cancel", Command.CANCEL, 1);
	
	private IAccount account;
	
	private IDispatcher dispatcher;

	private TextField firstNameText = new TextField("First name", "", 30,
			TextField.INITIAL_CAPS_WORD);

	private TextField lastNameText = new TextField("Last name", "", 30,
			TextField.INITIAL_CAPS_WORD);
	
	public AccountInfoView()
	{
		super("Account info");
		
		insert(0, firstNameText);
		insert(1, lastNameText);
		
		setItemStateListener(new ItemStateListener()
		{	
			public void itemStateChanged(Item item)
			{
				onItemUpdated(item);
			}
		});
		
		addCommand(CANCEL_CMD);
		addCommand(NEXT_CMD);
	}

	public void setAccount(IAccount account)
	{
		this.account = account;
		
		firstNameText.setString(account.getFirstName());
		lastNameText.setString(account.getLastName());
	}

	public IAccount getAccount()
	{
		return account;
	}
	
	protected void onItemUpdated(Item item)
	{
		if (item == firstNameText)
		{
			account.setFirstName(firstNameText.getString());
		}
		else if (item == lastNameText)
		{
			account.setLastName(lastNameText.getString());
		}
	}
	
	protected boolean isValid(TextField text)
	{
		return ((text.getString() != null)
				&& (text.getString().length() > 0));
	}
	
	public boolean validate()
	{
		boolean result = isValid(firstNameText) && isValid(lastNameText);
		
		if (!result)
		{
			Display.getDisplay(dispatcher.getMIDlet())
					.setCurrent(
					new Alert("Validation error",
							"First and last name need to be provided",
							null, AlertType.WARNING),
					this);
		}
		
		return result;
	}

	public IDispatcher getDispatcher()
	{
		return dispatcher;
	}

	public void setDispatcher(IDispatcher dispatcher)
	{
		this.dispatcher = dispatcher;
	}
}
