package com.aurorasoftworks.signal.examples.ui.mvc.midp;


import javax.microedition.lcdui.Command;

import com.aurorasoftworks.signal.examples.core.IAccount;
import com.aurorasoftworks.signal.runtime.ui.mvc.IDispatcher;
import com.aurorasoftworks.signal.runtime.ui.mvc.IDispatcherAware;
import com.aurorasoftworks.signal.runtime.ui.mvc.midp.AbstractViewFlowController;
import com.aurorasoftworks.signal.runtime.ui.mvc.midp.ICommandHandler;


public class AccountInfoViewController extends AbstractViewFlowController
		implements IAccountSelectedEvent, IDispatcherAware
{
	public AccountInfoViewController(AccountInfoView view)
	{
		super(view);
		
		registerCommandHandler(AccountInfoView.NEXT_CMD,
				new ICommandHandler()
		{
			public void handleCommand(Command cmd)
			{
				if (getAccountInfoView().validate())
				{
					((IAccountCreationEvent) getCaller()).onAccountSubmitted(
							getAccountInfoView().getAccount());
				}
			}
		});
		
		registerCommandHandler(AccountInfoView.CANCEL_CMD,
				new ICommandHandler()
		{
			public void handleCommand(Command cmd)
			{
				((IAccountCreationEvent) getCaller()).onAccountCancelled(
						getAccountInfoView().getAccount());
			}
		});
	}
	
	protected AccountInfoView getAccountInfoView()
	{
		return (AccountInfoView) getView();
	}

	public void onAccountSelected(IAccount account)
	{
		getAccountInfoView().setAccount(account);		
	}

	public IDispatcher getDispatcher()
	{
		return getAccountInfoView().getDispatcher();
	}

	public void setDispatcher(IDispatcher dispatcher)
	{
		getAccountInfoView().setDispatcher(dispatcher);
	}
}
