package com.aurorasoftworks.signal.examples.ui.mvc.midp;


import java.util.Enumeration;
import java.util.Vector;

import javax.microedition.lcdui.Choice;
import javax.microedition.lcdui.Command;
import javax.microedition.lcdui.List;

import com.aurorasoftworks.signal.examples.core.IAccount;



public class AccountListView extends List
{
	public static final Command NEW_ACCOUNT_CMD = new Command(
			"New", Command.ITEM, 2);

	public static final Command EDIT_ACCOUNT_CMD = new Command(
			"Edit", Command.ITEM, 2);
	
	public static final Command EXIT_CMD = new Command(
			"Exit",	Command.EXIT, 1);
	
	private Vector accounts;
	
	public AccountListView()
	{
		super("Account list", Choice.IMPLICIT);

		addCommand(NEW_ACCOUNT_CMD);
		addCommand(EDIT_ACCOUNT_CMD);
		addCommand(EXIT_CMD);
	}

	public IAccount getSelectedAccount()
	{
		IAccount result;
		int index = getSelectedIndex();
		
		if (index >= 0)
		{
			result = (IAccount) accounts.elementAt(index);
		}
		else
		{
			result = null;
		}
		
		return result;
	}

	public void setAccounts(Vector accounts)
	{
		this.accounts = accounts;
		deleteAll();
		
		for (Enumeration en = accounts.elements(); en.hasMoreElements();)
		{
			IAccount account = (IAccount) en.nextElement();
			append(account.toString(), null);
		}
	}
}
