package com.aurorasoftworks.signal.examples.ui.mvc.midp;


import javax.microedition.lcdui.Choice;
import javax.microedition.lcdui.ChoiceGroup;
import javax.microedition.lcdui.Command;
import javax.microedition.lcdui.Form;
import javax.microedition.lcdui.Item;
import javax.microedition.lcdui.ItemStateListener;

import com.aurorasoftworks.signal.examples.core.IAccount;



public class AccountPermissionsView extends Form
{
	public static final Command SAVE_CMD = new Command(
			"Save", Command.ITEM, 1);
	
	public static final Command CANCEL_CMD = new Command(
			"Cancel", Command.CANCEL, 1);
	
	protected static final int CAN_PLACE_ORDERS_INDEX = 0;
	
	protected static final int CAN_VIEW_ORDERS_INDEX = 1;
	
	protected static final int CAN_MODIFY_ORDERS_INDEX = 2;
	
	private boolean [] selectedPermissions
			= new boolean[CAN_MODIFY_ORDERS_INDEX + 1];
	
	private IAccount account;

	private ChoiceGroup permissionChoices = new ChoiceGroup("Permissions",
			Choice.MULTIPLE,
			new String[]
			{
				"Can place orders", "Can view orders", "Can modify orders"
			},
			null);
	
	public AccountPermissionsView()
	{
		super("Account permissions");
		
		insert(size(), permissionChoices);
		setItemStateListener((new ItemStateListener()
		{
			public void itemStateChanged(Item item)
			{
				if (item == permissionChoices)
				{
					syncPermissions();
				}
			}
		}));
		
		addCommand(CANCEL_CMD);
		addCommand(SAVE_CMD);
	}

	public IAccount getAccount()
	{
		return account;
	}

	public void setAccount(IAccount account)
	{
		this.account = account;
		
		permissionChoices.setSelectedIndex(CAN_PLACE_ORDERS_INDEX,
				account.getCanPlaceOrders());
		permissionChoices.setSelectedIndex(CAN_VIEW_ORDERS_INDEX,
				account.getCanViewOrders());
		permissionChoices.setSelectedIndex(CAN_MODIFY_ORDERS_INDEX,
				account.getCanModifyOrders());
	}
	
	protected void syncPermissions()
	{
		permissionChoices.getSelectedFlags(selectedPermissions);
		account.setCanPlaceOrders(
				selectedPermissions[CAN_PLACE_ORDERS_INDEX]);
		account.setCanViewOrders(
				selectedPermissions[CAN_VIEW_ORDERS_INDEX]);
		account.setCanModifyOrders(
				selectedPermissions[CAN_MODIFY_ORDERS_INDEX]);
	}
}
