/*
 * Copyright 2009-2010 the original author or authors.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package com.aurorasoftworks.signal.runtime.core.context;


/**
 * Signals an error encountered while processing a context. 
 * 
 * @author Marek
 */
public class ContextException extends RuntimeException
{
	/**
	 * Creates a new {@link ContextException} instance.
	 * 
	 * @param message a message to initialize the new instance with
	 */
	public ContextException(String message)
	{
		super(message);
	}

	/**
	 * Creates a new {@link ContextException} instance.
	 * 
	 * @param cause a cause to initialize the new instance with
	 */
	public ContextException(Exception cause)
	{
		this(cause.toString());
	}
	
	/**
	 * Creates a new {@link ContextException} instance.
	 * 
	 * @param message a message to initialize the new instance with
	 * @param cause a cause to initialize the new instance with
	 */
	public ContextException(String message, Exception cause)
	{
		this(message + ": " + cause.toString());
	}
}
