/*
 * Copyright 2009-2010 the original author or authors.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package com.aurorasoftworks.signal.runtime.core.context;


/**
 * A context loader API. Implementations of this interface
 * can load context instances from any varios types of resources
 * (file, class, etc.).
 * 
 * @author Marek
 */
public interface IContextLoader
{
	/**
	 * Loads a context from the specified location.
	 * 
	 * @param contextName a name that uniquely identifies a context to
	 *                    be loaded (e.g. a file name). The exact meaning
	 *                    of this parameter depends on the implementation.
	 * @return new context instance
	 * @throws ContextException if an error occurs while loading the context
	 */
	IContext loadContext(String contextName) throws ContextException;
}
