/*
 * Copyright 2009-2010 the original author or authors.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package com.aurorasoftworks.signal.runtime.ui.mvc.lwuit;



import com.aurorasoftworks.signal.runtime.core.context.ContextException;
import com.aurorasoftworks.signal.runtime.core.context.IContext;
import com.aurorasoftworks.signal.runtime.core.context.IContextLoader;
import com.sun.lwuit.Display;


public class AbstractApplicationMIDlet extends
		com.aurorasoftworks.signal.runtime.ui.mvc.AbstractApplicationMIDlet
{
	public AbstractApplicationMIDlet(String contextName,
			IContextLoader loader) throws ContextException
	{
		super(contextName, loader);
		initializeDispatcher();
	}

	public AbstractApplicationMIDlet(String contextName)
			throws ContextException
	{
		super(contextName);
		initializeDispatcher();
	}

	protected IContext loadContext(String contextName, IContextLoader loader)
			throws ContextException
	{
		/* Initialize LWUIT before loading the context */
		Display.init(this);
		
		return super.loadContext(contextName, loader);
	}
}
