/*
 * Copyright 2009-2010 the original author or authors.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package com.aurorasoftworks.signal.runtime.ui.mvc.lwuit;


import com.aurorasoftworks.signal.runtime.ui.mvc.AbstractMIDletDispatcher;
import com.aurorasoftworks.signal.runtime.ui.mvc.IController;
import com.sun.lwuit.events.ActionEvent;
import com.sun.lwuit.events.ActionListener;


public class Dispatcher extends AbstractMIDletDispatcher
		implements ActionListener
{	
	protected void activateController(IController controller)
	{
		if (controller instanceof IViewController)
		{
			IViewController viewController = (IViewController) controller;
			viewController.getView().setCommandListener(this);	
			viewController.activate();
			viewController.getView().show();
		}
		else
		{
			controller.activate();
		}
	}

	protected void deactivateController(IController controller)
	{
		controller.deactivate();
		
		if (controller instanceof IViewController)
		{
			((IViewController) controller).getView().setCommandListener(null);
		}
	}

	public void actionPerformed(ActionEvent event)
	{
		if (getCurrentController() instanceof ICommandHandler)
		{
			((ICommandHandler) getCurrentController()).handleCommand(
					event.getCommand());
		}
	}
}
