/*
 * Copyright 2009-2010 the original author or authors.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package com.aurorasoftworks.signal.runtime.ui.mvc;


import javax.microedition.midlet.MIDlet;
import javax.microedition.midlet.MIDletStateChangeException;

import com.aurorasoftworks.signal.runtime.core.context.ContextClassLoader;
import com.aurorasoftworks.signal.runtime.core.context.ContextException;
import com.aurorasoftworks.signal.runtime.core.context.IContext;
import com.aurorasoftworks.signal.runtime.core.context.IContextLoader;



public abstract class AbstractApplicationMIDlet extends MIDlet
{
	private IContext context;
	
	protected AbstractApplicationMIDlet(String contextName)
			throws ContextException
	{
		this(contextName, ContextClassLoader.getInstance());
	}
	
	protected AbstractApplicationMIDlet(String contextName,
			IContextLoader loader) throws ContextException
	{
		context = loadContext(contextName, loader);
	}
	
	protected void initializeDispatcher() throws ContextException
	{
		((AbstractMIDletDispatcher) getContext().getBean(IDispatcher.class))
				.setMIDlet(this);
	}

	protected IContext loadContext(String contextName,
			IContextLoader loader) throws ContextException
	{
		return loader.loadContext(contextName);
	}

	protected IContext getContext()
	{
		return context;
	}

	protected void destroyApp(boolean unconditional)
			throws MIDletStateChangeException
	{		
	}

	protected void pauseApp()
	{	
	}

	protected void startApp() throws MIDletStateChangeException
	{		
	}
}
