/*
 * Copyright 2009-2010 the original author or authors.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package com.aurorasoftworks.signal.runtime.ui.mvc;


/**
 * A controller of a flow, that is a sequence of activites
 * that produces a certain result. The most common
 * type of a flow is a wizard consisting of multiple screens.
 * A flow has its caller, that is a contoller that started it.
 * Upon completion, a flow returns a result to its caller
 * by invoking a caller's method. It is possible to chain
 * flows, that is flow controllers might start other flows.
 * 
 * @author Marek
 */
public interface IFlowController extends IController
{
	void setCaller(IController caller);
	
	IController getCaller();
}
