/*
 * Copyright 2009-2010 the original author or authors.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package com.aurorasoftworks.signal.runtime.ui.mvc;


import com.aurorasoftworks.signal.runtime.core.context.proxy.AbstractMethodHandler;
import com.aurorasoftworks.signal.runtime.core.context.proxy.AbstractProxyClass;
import com.aurorasoftworks.signal.runtime.core.context.proxy.IMethodHandler;
import com.aurorasoftworks.signal.runtime.core.context.proxy.IProxyTarget;


public class MockController__ProxyClass extends AbstractProxyClass
{
	static final IMethodHandler ACTIVATE_HANDLER
			= new AbstractMethodHandler("activate", new Class[]{})
	{
		public Object invoke(IProxyTarget target, Object[] args)
				throws Exception
		{
			((ISimpleController) target).activate();
			return null;
		}
	};
	
	static final IMethodHandler DEACTIVATE_HANDLER
			= new AbstractMethodHandler("deactivate", new Class[]{})
	{
		public Object invoke(IProxyTarget target, Object[] args)
				throws Exception
		{
			((ISimpleController) target).deactivate();
			return null;
		}
	};
	
	static final IMethodHandler PERFORM_HANDLER
			= new AbstractMethodHandler("perform", new Class[]{})
	{
		public Object invoke(IProxyTarget target, Object[] args)
				throws Exception
		{
			((ISimpleController) target).perform();
			return null;
		}
	};
	
	static final IMethodHandler ON_RETURN_HANDLER
			= new AbstractMethodHandler("onReturn", new Class[]{})
	{
		public Object invoke(IProxyTarget target, Object[] args)
				throws Exception
		{
			((IReturnEvent) target).onReturn();
			return null;
		}
	};
	
	public MockController__ProxyClass()
	{
		registerHandlers(new IMethodHandler[]{ACTIVATE_HANDLER});
		registerHandlers(new IMethodHandler[]{DEACTIVATE_HANDLER});
		registerHandlers(new IMethodHandler[]{PERFORM_HANDLER});
	}
}
