/*
 * Copyright 2009-2010 the original author or authors.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package com.aurorasoftworks.signal.runtime.core.context.proxy;


import java.lang.reflect.InvocationHandler;


/**
 * A handler of intercepted method invocations.
 * This type is similar to {@link InvocationHandler}.
 * 
 * @author Marek
 */
public interface IInvocationHandler
{
	/**
	 * 
	 * @param target  the instance an intercepted method
	 *                was invoked on 
	 * @param handler method object identifying the intercepted method 
	 * @param args    list of arguments passed to the intercepted method
	 * @return        a value to be returned by the intercepted method
	 * @throws Exception
	 */
	Object invoke(IProxyTarget target, IMethodHandler handler,
			Object [] args)	throws Exception;
}
