/*
 * Copyright 2009-2010 the original author or authors.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package com.aurorasoftworks.signal.tools.core.context.loader;


public class BeanReference implements IBeanReference
{
	private String name;
	
	private Object object;
	
	public BeanReference(String name, Object object)
	{
		this.name = name;
		this.object = object;
	}

	public String getName()
	{
		return name;
	}

	public Object getObject()
	{
		return object;
	}
	
	public String toString()
	{
		return name + ": " + object.getClass().getName();
	}

	@Override
	public int hashCode()
	{
		final int prime = 31;
		int result = prime + name.hashCode();
		result = prime * result + object.hashCode();
		return result;
	}

	@Override
	public boolean equals(Object obj)
	{
		boolean result;
		
		if (obj instanceof BeanReference)
		{
			BeanReference ref = (BeanReference) obj;
			result = name.equals(ref.name) && (object.equals(ref.object));
		}
		else
		{
			result = false;
		}
		
		return result;
	}
}
