/*
 * Copyright 2009-2010 the original author or authors.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package com.aurorasoftworks.signal.tools.core.context.loader;


import java.lang.reflect.Constructor;
import java.lang.reflect.Method;

import com.aurorasoftworks.signal.tools.core.context.generator.ContextGeneratorException;



/**
 * @author Marek
 */
public interface IContextLoaderListener
{
	void onBeanInstantiated(IBeanInfo beanInfo,
			Constructor<?> ctor, Object [] args)
			throws ContextGeneratorException;
	
	void onBeanInstantiated(IBeanInfo beanInfo,
			Method factoryMethod, Object [] args)
			throws ContextGeneratorException;
	
	void onBeanInstantiated(IBeanInfo beanInfo,
			IBeanInfo factoryBeanInfo,
			Method factoryMethod, Object [] args)
			throws ContextGeneratorException;
	
	void onBeanPropertySet(IBeanInfo beanInfo,
			String propertyName, Object value)
			throws ContextGeneratorException;
	
	void onBeanMethodInvoked(IBeanInfo beanInfo,
			Method method, Object [] args)
			throws ContextGeneratorException;

	void onBeanPreProcess(IBeanInfo beanInfo,
			IBeanInfo processorBeanInfo)
			throws ContextGeneratorException;
	
	void onBeanPostProcess(IBeanInfo beanInfo,
			IBeanInfo processorBeanInfo)
			throws ContextGeneratorException;
}
