/*
 * Copyright 2009-2010 the original author or authors.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package com.aurorasoftworks.signal.tools.core.context.loader.spring;


import java.beans.PropertyEditor;
import java.beans.PropertyEditorSupport;
import java.util.Collection;
import java.util.Vector;


public class VectorPropertyEditor extends PropertyEditorSupport
{
	private static final PropertyEditor INSTANCE
			= new VectorPropertyEditor();
	
	public static PropertyEditor getInstance()
	{
		return INSTANCE;
	}
	
	protected VectorPropertyEditor()
	{
	}
	
	@Override
	public void setValue(Object value)
	{
		Object newValue;
		
		if (value instanceof Collection<?>)
		{
			Vector<Object> v = new Vector<Object>();
			Collection <?> c = (Collection<?>) value;
			
			for (Object e : c)
			{
				v.add(e);
			}
			
			newValue = v;
		}
		else
		{
			newValue = value;
		}
		
		super.setValue(newValue);
	}
}
