package com.aurorasoftworks.signal.tools.core.context.loader;


public class LazyController implements ILazyController
{
	private static int instanceCount;
	
	private static int activationCount;
	
	private static int deactivationCount;
	
	public static void resetCounters()
	{
		instanceCount = 0;
		activationCount = 0;
		deactivationCount = 0;
	}

	public static int getInstanceCount()
	{
		return instanceCount;
	}

	public static int getActivationCount()
	{
		return activationCount;
	}

	public static int getDeactivationCount()
	{
		return deactivationCount;
	}

	public LazyController()
	{
		instanceCount++;
	}

	public void activate()
	{
		activationCount++;
	}

	public void deactivate()
	{
		deactivationCount++;
	}
	
	public void doSomething()
	{
	}
}
