package com.aurorasoftworks.signal.tools.core.context.loader;


import com.aurorasoftworks.signal.runtime.core.context.proxy.IProxyTarget;


public class LazyProxyTarget implements IProxyTarget, IProxyTargetChild
{
	private static int instanceCount;
	
	public synchronized static int getInstanceCount()
	{
		return instanceCount;
	}
	
	public synchronized static void resetInstanceCount()
	{
		instanceCount = 0;
	}
	
	public LazyProxyTarget()
	{
		instanceCount++;
	}

	public void first()
	{		
	}

	public String second()
	{
		return "2nd";
	}

	public String third()
	{
		return "3rd";
	}
}
